<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="worksheetId"
          :columns="columns"
          :datasource="datasource"
          v-model:selection="selection"
          tool-class="ele-toolbar-form"
          :scroll="{ x: 800 }"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'status'">
              <span>{{ WORKSHEET_STATUS_LIST[record.status] }}</span>
            </template>
            <template v-if="column.key === 'equipmentType'">
              <span>{{ WORKSHEET_EQUIPMENT_TYPE[record.equipmentType] }}</span>
            </template>
            <template v-if="column.key === 'workType'">
              <span>{{ WORKSHEET_WORK_TYPE[record.workType] }}</span>
            </template>
            <template v-if="column.key === 'startUser'">
              <span>{{ record.startUser ?.nickname }}</span>
            </template>
            <template v-if="column.key === 'productionMangerUser'">
              <span>{{ record.productionMangerUser ?.nickname }}</span>
            </template>
            <template v-if="column.key === 'documentUser'">
              <span>{{ record.documentUser ?.nickname }}</span>
            </template>
            <template v-if="column.key === 'classManagerUser'">
              <span>{{ record.classManagerUser?.nickname }}</span>
            </template>
            <template v-if="column.key === 'createTime'">
              <a-tooltip :title="`${toDateString(record.createTime)}`">
                {{ timeAgo(record.createTime) }}
              </a-tooltip>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openInfo(record, 0)">查看安装单派单详情</a>
                <a @click="openInfo(record, 1)">查看加高单派单详情</a>
                <a @click="openInfo(record, 2)">查看拆卸单派单详情</a>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>
    </div>
    <Info v-model:visible="showInfo" :data="current" :work-type="workType"/>
  </div>
</template>

<script lang="ts" setup>
import { computed, createVNode, ref } from "vue";
import { message, Modal } from "ant-design-vue";
import {
  ExclamationCircleOutlined,
  UserOutlined
} from "@ant-design/icons-vue";
import type { EleProTable } from "ele-admin-pro";
import type {
  DatasourceFunction,
  ColumnItem
} from "ele-admin-pro/es/ele-pro-table/types";
import { toDateString } from "ele-admin-pro";
import Info from "./info.vue";
import { timeAgo } from "ele-admin-pro";
import { useUserStore } from "@/store/modules/user";
import {
  Worksheet,
  WORKSHEET_EQUIPMENT_TYPE,
  WORKSHEET_STATUS_LIST, WORKSHEET_WORK_TYPE,
  WorksheetParam
} from "@/api/tower/worksheet/model";
import { pageWorksheet, removeBatchWorksheet, removeWorksheet } from "@/api/tower/worksheet";

const userStore = useUserStore();
// 当前用户信息
const loginUser = computed(() => userStore.info ?? {});

// 表格实例
const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

// 表格选中数据
const selection = ref<Worksheet[]>([]);
// 当前编辑数据
const current = ref<Worksheet | null>(null);

// 是否显示资产详情
const showInfo = ref(false);
// 是否显示批量移动弹窗
const showMove = ref(false);

// 表格数据源
const datasource: DatasourceFunction = ({
                                          page,
                                          limit,
                                          where,
                                          orders,
                                          filters
                                        }) => {
  if (filters) {
    where.status = filters.status;
  }
  return pageWorksheet({
    ...where,
    ...orders,
    page,
    limit
  });
};

// 表格列配置
const columns = ref<ColumnItem[]>([
  {
    key: "index",
    width: 48,
    align: "center",
    fixed: "left",
    hideInSetting: true,
    customRender: ({ index }) => index + (tableRef.value?.tableIndex ?? 0)
  },
  {
    title: "项目名称",
    dataIndex: "projectName"
  },
  {
    title: "操作",
    key: "action",
    width: 400,
    align: "center",
    hideInSetting: true
  }
]);

/* 搜索 */
const reload = (where?: WorksheetParam) => {
  selection.value = [];
  tableRef?.value?.reload({ where: where });
};

const showSettle = ref<Boolean>(false);
const openSettle = (row?: Worksheet) => {
  current.value = row ?? null;
  showSettle.value = true;
};

/* 打开批量移动弹窗 */
const openMove = () => {
  showMove.value = true;
};

const workType = ref<number>(0)
/* 打开用户详情弹窗 */
const openInfo = (row: Worksheet, workTypeValue: number) => {
  current.value = row;
  workType.value = workTypeValue;
  showInfo.value = true;
};

/* 删除单个 */
const remove = (row: Worksheet) => {
  const hide = message.loading("请求中..", 0);
  removeWorksheet(row.worksheetId)
    .then((msg) => {
      hide();
      message.success(msg);
      reload();
    })
    .catch((e) => {
      hide();
      message.error(e.message);
    });
};

/* 批量转移 */
const batchMove = (userId) => {
  console.log(userId, "批量转移0000");
  console.log(selection.value);
};

/* 批量删除 */
const removeBatch = () => {
  if (!selection.value.length) {
    message.error("请至少选择一条数据");
    return;
  }
  Modal.confirm({
    title: "提示",
    content: "确定要删除选中的记录吗?",
    icon: createVNode(ExclamationCircleOutlined),
    maskClosable: true,
    onOk: () => {
      const hide = message.loading("请求中..", 0);
      removeBatchWorksheet(
        selection.value.map((d) => {
          return d.worksheetId;
        })
      )
        .then((msg) => {
          hide();
          message.success(msg);
          reload();
        })
        .catch((e) => {
          hide();
          message.error(e.message);
        });
    }
  });
};
</script>

<script lang="ts">
export default {
  name: "Accessory"
};
</script>

<style lang="less" scoped>
.sys-org-table :deep(.ant-table-body) {
  overflow: auto !important;
  overflow: overlay !important;
}

.sys-org-table :deep(.ant-table-pagination.ant-pagination) {
  padding: 0 4px;
  margin-bottom: 0;
}
</style>
